xine-lib: xine-lib-1.2.13/src/demuxers/demux_rawdv.c File Reference

xine-lib 1.2.13-20230125hg15249

Data Structures | Macros | Functions
demux_rawdv.c File Reference
`#include <stdio.h>`
`#include <stdlib.h>`
`#include <fcntl.h>`
`#include <unistd.h>`
`#include <string.h>`
`#include "group_video.h"`
`#include <xine/xine_internal.h>`
`#include <xine/xineutils.h>`
`#include <xine/compat.h>`
`#include <xine/demux.h>`

## Data Structures
struct | demux_raw_dv_t

## Macros
#define | LOG_MODULE "demux_rawdv"
#define | NTSC_FRAME_SIZE 120000
#define | NTSC_FRAME_RATE 29.97
#define | PAL_FRAME_SIZE 144000
#define | PAL_FRAME_RATE 25

## Functions
static int | demux_raw_dv_next (demux_raw_dv_t *this)
static int | demux_raw_dv_send_chunk (demux_plugin_t *this_gen)
static int | demux_raw_dv_get_status (demux_plugin_t *this_gen)
static void | demux_raw_dv_send_headers (demux_plugin_t *this_gen)
static int | demux_raw_dv_seek (demux_plugin_t *this_gen, off_t start_pos, int start_time, int playing)
static int | demux_raw_dv_get_stream_length (demux_plugin_t *this_gen)
static uint32_t | demux_raw_dv_get_capabilities (demux_plugin_t *this_gen)
static int | demux_raw_dv_get_optional_data (demux_plugin_t *this_gen, void *data, int data_type)
static demux_plugin_t * | open_plugin (demux_class_t *class_gen, xine_stream_t *stream, input_plugin_t *input)
void * | demux_rawdv_init_class (xine_t *xine, const void *data)

## Macro Definition Documentation

## ◆ LOG_MODULE

#define LOG_MODULE "demux_rawdv"

## ◆ NTSC_FRAME_RATE

#define NTSC_FRAME_RATE 29.97

Referenced by demux_raw_dv_send_headers().

## ◆ NTSC_FRAME_SIZE

#define NTSC_FRAME_SIZE 120000

Referenced by demux_raw_dv_send_headers().

## ◆ PAL_FRAME_RATE

#define PAL_FRAME_RATE 25

Referenced by demux_raw_dv_send_headers().

## ◆ PAL_FRAME_SIZE

#define PAL_FRAME_SIZE 144000

Referenced by demux_raw_dv_send_headers().

## Function Documentation

## ◆ demux_raw_dv_get_capabilities()

static uint32_t demux_raw_dv_get_capabilities | ( | demux_plugin_t * | this_gen | ) |
| static

References DEMUX_CAP_NOCAP.

Referenced by open_plugin().

## ◆ demux_raw_dv_get_optional_data()

static int demux_raw_dv_get_optional_data | ( | demux_plugin_t * | this_gen,
|  | void * | data,
|  | int | data_type )
| static

References DEMUX_OPTIONAL_UNSUPPORTED.

Referenced by open_plugin().

## ◆ demux_raw_dv_get_status()

static int demux_raw_dv_get_status | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_raw_dv_get_stream_length()

static int demux_raw_dv_get_stream_length | ( | demux_plugin_t * | this_gen | ) |
| static

References input().

Referenced by open_plugin().

## ◆ demux_raw_dv_next()

static int demux_raw_dv_next | ( | demux_raw_dv_t * | this | ) |
| static

References BUF_AUDIO_DV, BUF_FLAG_FRAME_END, BUF_VIDEO_DV, buf_element_s::content, buf_element_s::decoder_flags, buf_element_s::extra_info, extra_info_s::frame_number, buf_element_s::free_buffer, input(), extra_info_s::input_normpos, extra_info_s::input_time, buf_element_s::max_size, buf_element_s::mem, buf_element_s::pts, buf_element_s::size, and buf_element_s::type.

Referenced by demux_raw_dv_send_chunk().

## ◆ demux_raw_dv_seek()

static int demux_raw_dv_seek | ( | demux_plugin_t * | this_gen,
|  | off_t | start_pos,
|  | int | start_time,
|  | int | playing )
| static

References _x_demux_control_newpts(), _x_demux_flush_engine(), BUF_FLAG_SEEK, DEMUX_OK, input(), INPUT_IS_SEEKABLE, and demux_plugin_s::seek.

Referenced by open_plugin().

## ◆ demux_raw_dv_send_chunk()

static int demux_raw_dv_send_chunk | ( | demux_plugin_t * | this_gen | ) |
| static

References DEMUX_FINISHED, and demux_raw_dv_next().

Referenced by open_plugin().

## ◆ demux_raw_dv_send_headers()

static void demux_raw_dv_send_headers | ( | demux_plugin_t * | this_gen | ) |
| static

References _x_demux_control_start(), _x_stream_info_set(), xine_bmiheader::biBitCount, xine_bmiheader::biCompression, xine_bmiheader::biHeight, xine_bmiheader::biPlanes, xine_bmiheader::biSize, xine_bmiheader::biSizeImage, xine_bmiheader::biWidth, BUF_AUDIO_DV, BUF_FLAG_FRAME_END, BUF_FLAG_FRAMERATE, BUF_FLAG_HEADER, BUF_FLAG_STDHEADER, BUF_VIDEO_DV, buf_element_s::content, buf_element_s::decoder_flags, buf_element_s::decoder_info, DEMUX_OK, input(), INPUT_IS_SEEKABLE, buf_element_s::mem, NTSC_FRAME_RATE, NTSC_FRAME_SIZE, NULL, PAL_FRAME_RATE, PAL_FRAME_SIZE, buf_element_s::size, buf_element_s::type, XINE_STREAM_INFO_HAS_AUDIO, XINE_STREAM_INFO_HAS_VIDEO, XINE_STREAM_INFO_VIDEO_BITRATE, XINE_STREAM_INFO_VIDEO_HEIGHT, and XINE_STREAM_INFO_VIDEO_WIDTH.

Referenced by open_plugin().

## ◆ demux_rawdv_init_class()

void * demux_rawdv_init_class | ( | xine_t * | xine,
|  | const void * | data )

References demux_plugin_s::dispose, N_, NULL, demux_class_s::open_plugin, and open_plugin().

## ◆ open_plugin()

static demux_plugin_t * open_plugin | ( | demux_class_t * | class_gen,
|  | xine_stream_t * | stream,
|  | input_plugin_t * | input )
| static

References _x_demux_read_header(), xine_stream_s::content_detection_method, default_demux_plugin_dispose, DEMUX_FINISHED, demux_raw_dv_get_capabilities(), demux_raw_dv_get_optional_data(), demux_raw_dv_get_status(), demux_raw_dv_get_stream_length(), demux_raw_dv_seek(), demux_raw_dv_send_chunk(), demux_raw_dv_send_headers(), input(), INPUT_IS_SEEKABLE, METHOD_BY_CONTENT, METHOD_BY_MRL, METHOD_EXPLICIT, xine_stream_s::metronom, METRONOM_PREBUFFER, NULL, input_plugin_s::seek, and metronom_s::set_option.

Referenced by demux_rawdv_init_class().